angular.module('stow.controllers')
    .controller('FAQCtrl', function ($rootScope, $scope, $stateParams, $ionicSlideBoxDelegate, $ionicScrollDelegate, $ionicHistory) {

        if (typeof analytics !== "undefined") {
            analytics.trackView("FAQ");
        }

        $scope.init = function () {
            $ionicSlideBoxDelegate.enableSlide(false);
            if ($stateParams.view) {
                if ($stateParams.view === 'renter') {
                    $scope.changeSlide(1);
                } else if ($stateParams.view === 'owner') {
                    $scope.changeSlide(2);
                }
            } else {
                $scope.changeSlide(0);
            }
        };

        // Change the slide within the ion-slide-box
        $scope.changeSlide = function (slideNumber, title) {
            $scope.showOverlay = true;
            $ionicScrollDelegate.scrollTop();
            switch (slideNumber) {
                case 0:
                    $scope.title = "FAQ";
                    break;
                case 1:
                    $scope.title = "Renter FAQ";
                    break;
                case 2:
                    $scope.title = "Owner FAQ"
            }
            $scope.slide = slideNumber;
            $ionicSlideBoxDelegate.slide(slideNumber);
            $ionicSlideBoxDelegate.update();
            $scope.showOverlay = false;
        };

        $scope.checkBack = function () {
            if ($scope.slide === 0 || $stateParams.view) {
                $ionicHistory.goBack();
            } else {
                $scope.changeSlide(0);
            }
        };

        $scope.$on("$ionicView.beforeEnter", function () {
            $rootScope.checkSession();
        });
    });