angular.module('stow.controllers')
    .controller('LegalCtrl', function ($rootScope, $scope, $stateParams, $ionicSlideBoxDelegate, $ionicScrollDelegate, $ionicHistory) {

        if (typeof analytics !== "undefined") {
            analytics.trackView("Legal");
        }

        $scope.init = function () {
            if ($stateParams.view) {
                if ($stateParams.view === "terms") {
                    $scope.changeSlide(1, "Terms and Conditions");
                } else if ($stateParams.view === "privacy") {
                    $scope.changeSlide(1, "Privacy Policy");
                }
            } else {
                $ionicSlideBoxDelegate.enableSlide(false);
                $scope.changeSlide(0, "Legal");
                $scope.showTerms = $scope.showPrivacy = false;
            }
        };

        // Change the slide within the ion-slide-box
        $scope.changeSlide = function (slideNumber, title) {
            $scope.showOverlay = true;
            $ionicScrollDelegate.scrollTop();
            $scope.title = title;
            if (slideNumber === 1) {
                if (title === "Privacy Policy") {
                    $scope.showPrivacy = true;
                    $scope.showTerms = false;
                } else {
                    $scope.showPrivacy = false;
                    $scope.showTerms = true;
                }
            } else {
                $scope.showTerms = $scope.showPrivacy = false;
            }
            $scope.slide = slideNumber;
            $ionicSlideBoxDelegate.slide(slideNumber);
            $ionicSlideBoxDelegate.update();
            $scope.showOverlay = false;
        };

        $scope.checkBack = function () {
            if ($scope.slide === 0 || $stateParams.view) {
                $ionicHistory.goBack();
            } else {
                $scope.changeSlide(0, "Legal");
            }
        };

        $scope.$on("$ionicView.beforeEnter", function () {
            $rootScope.checkSession();
        });
    });