var AuthenticateService = angular.module('AccountService', [])

    .service('Account', [
        '$http',
        '$q',
        '$state',
        '$rootScope',
        function ($http, $q, $state, $rootScope) {
            return {
                getUserData: function(){
                    var deferred = $q.defer();
                    // Prepare request for user information
                    var req = {
                        method: 'GET',
                        url: $rootScope.stowSecureURL + '/user',
                        headers: {
                            'Authorization': 'jwt ' + $rootScope.user.token,
                            'Content-Type': 'application/json'
                        }
                    };
                    $http(req).
                        success(function (data) {
                            deferred.resolve(data);
                        }).
                        error(function (data, status) {
                            deferred.reject(data);
                            if(status == 401){
                                $rootScope.forceLogout();
                            }
                        });
                    return deferred.promise;
                },
                saveData: function(userData){
                    var deferred = $q.defer();
                    var req = {
                        method: 'PATCH',
                        url: $rootScope.stowSecureURL + '/user',
                        headers: {
                            'Authorization': 'jwt ' + $rootScope.user.token,
                            'Content-Type': 'application/json'
                        },
                        data: userData
                    };
                    console.log(req);
                    $http(req).
                        success(function () {
                            deferred.resolve(true);
                        }).
                        error(function (data) {
                            deferred.reject(data);
                            console.log(data);
                            if(status == 401){
                                $rootScope.forceLogout();
                            }
                        });

                    return deferred.promise;
                },
                deactivateAccount: function() {
                    var deferred = $q.defer();
                    var req = {
                        method: 'DELETE',
                        url: $rootScope.stowSecureURL + '/account',
                        headers: {
                            'Authorization': 'jwt ' + $rootScope.user.token,
                            'Content-Type': 'application/json'
                        }
                    };
                    $http(req).
                        success(function () {
                            deferred.resolve(true);
                        }).
                        error(function (data) {
                            deferred.reject(data);
                            if(status == 401){
                                $rootScope.forceLogout();
                            }
                        });

                    return deferred.promise;
                },
                reactivateAccount: function() {
                    var deferred = $q.defer();
                    var req = {
                        method: 'PUT',
                        url: $rootScope.stowSecureURL + '/account',
                        headers: {
                            'Authorization': 'jwt ' + $rootScope.user.token,
                            'Content-Type': 'application/json'
                        }
                    };
                    $http(req).
                        success(function () {
                            deferred.resolve(true);
                        }).
                        error(function (data) {
                            deferred.reject(data);
                            if(status == 401){
                                $rootScope.forceLogout();
                            }
                        });

                    return deferred.promise;
                }
            }
        }]);