angular.module('stow.controllers')
    .controller('BankAccountCtrl', function ($rootScope, $scope, $state, $stateParams, BankAccount) {

        if (typeof analytics !== "undefined") {
            analytics.trackView("Bank Account");
        }

        $scope.showOverlay = true;
        BankAccount.getCustomerBankingData().then(function (result) {
            $scope.currentBankingData = result.data.data;
            $scope.currentBankingData.last4 = "****" + $scope.currentBankingData.last4;
            $scope.title = $scope.currentBankingData.bank_name;
            $scope.showOverlay = false;
        }, function (error) {
            if (error.status == 401) {
                $rootScope.forceLogout();
            }
            $rootScope.showMessage(error.data.message, "invalid");
        }).finally(function () {
            $scope.showOverlay = false;
        });

        $scope.$on("$ionicView.beforeEnter", function () {
            if(!$rootScope.user.paymet.hasDebitCard) {
                $rootScope.checkSession();
            } else {
                $ionicHistory.goBack();
            }
        });
    });