var CameraService = angular.module('BankAccountService', [])

    .service('BankAccount', [
        '$window',
        '$http',
        '$rootScope',
        '$q',
        function ($window, $http, $rootScope, $q) {
            return {
                getCustomerBankingData: function () {
                    var req = {
                        method: 'GET',
                        url: $rootScope.stowSecureURL + '/owner/account/banking/' + $rootScope.user.id,
                        headers: {
                            'Authorization': 'jwt ' + $rootScope.user.token
                        }
                    };

                    return $http(req);
                },
                saveAccountBankData: function (stripeBankToken) {
                    var req = {
                        method: 'PUT',
                        url: $rootScope.stowSecureURL + '/owner/account/banking/' + $rootScope.user.id,
                        headers: {
                            'Authorization': 'jwt ' + $rootScope.user.token
                        },
                        data: {stripeBankToken: stripeBankToken}
                    };

                    return $http(req);
                }
            }
        }]);

