angular.module('stow.controllers')
    .controller('CreditCardCtrl', function ($rootScope, $scope, $state, CreditCard) {

        if (typeof analytics !== "undefined") {
            analytics.trackView("Credit Card");
        }

        function init() {
            if ($rootScope.user.payment.hasCreditCard) {
                CreditCard.getCustomerCreditCardData().then(function (result) {
                    var currentCC = result.data.data.card;
                    $scope.title = currentCC.brand;
                    $scope.currentCCNumber = "**** **** **** " + currentCC.lastFour;
                    $scope.currentCCExpiration = currentCC.expMonth + "/" + currentCC.expYear;
                    $scope.showOverlay = false;
                }, function (error) {
                    if (error.status == 401) {
                        $rootScope.forceLogout();
                    }
                    $rootScope.showMessage(error.data.message, "invalid");
                });
            } else {
                $state.go("app.credit-card-edit");
            }
        }

        $scope.$on("$ionicView.beforeEnter", function () {
            $scope.showOverlay = true;
            if($rootScope.checkSession()) {
                init();
            }
        });
    });