var CameraService = angular.module('CreditCardService', [])

    .service('CreditCard', [
        '$window',
        '$http',
        '$rootScope',
        '$q',
        function ($window, $http, $rootScope, $q) {
            return {
                getCustomerCreditCardData: function () {
                    var req = {
                        method: 'GET',
                        url: $rootScope.stowSecureURL + '/payments/' + $rootScope.user.id,
                        headers: {
                            'Authorization': 'jwt ' + $rootScope.user.token
                        }
                    };

                    return $http(req);
                },
                deleteCustomerCreditCard: function () {
                    var req = {
                        method: 'DELETE',
                        url: $rootScope.stowSecureURL + '/payments/' + $rootScope.user.id,
                        headers: {
                            'Authorization': 'jwt ' + $rootScope.user.token
                        }
                    };

                    return $http(req);
                },
                updateCustomerCreditCardData: function (customerId) {
                    var req = {
                        method: 'PUT',
                        url: $rootScope.stowSecureURL + '/payments/' + $rootScope.user.id,
                        headers: {
                            'Authorization': 'jwt ' + $rootScope.user.token
                        },
                        data: {stripeId: customerId}
                    };

                    return $http(req);
                },
                saveCustomerCreditCardData: function (customerId) {
                    var req = {
                        method: 'POST',
                        url: $rootScope.stowSecureURL + '/payments',
                        headers: {
                            'Authorization': 'jwt ' + $rootScope.user.token
                        },
                        data: {stripeId: customerId}
                    };

                    return $http(req);
                }
            }
        }]);

