angular.module('stow.controllers')
    .controller('DebitCardCtrl', function ($rootScope, $scope, $state, DebitCard) {

        if (typeof analytics !== "undefined") {
            analytics.trackView("Debit Card");
        }

        function init() {
            if ($rootScope.user.payment.hasDebitCard) {
                DebitCard.getCustomerDebitCardData().then(function (result) {
                    $scope.currentCardData = result.data.data;
                    $scope.title = $scope.currentCardData.brand;
                    $scope.currentCardData.last4 = "****" + $scope.currentCardData.last4;
                    $scope.currentCardData.expiration = $scope.currentCardData.exp_month + "/" + $scope.currentCardData.exp_year;
                }, function (error) {
                    console.log(error);
                    if (error.status == 401) {
                        $rootScope.forceLogout();
                    }
                    $rootScope.showMessage(error.data.message, "invalid");
                }).finally(function() {
                    $scope.showOverlay = false;
                });
            } else {
                $state.go("app.debit-card-edit");
            }
        }

        $scope.$on("$ionicView.beforeEnter", function () {
            $scope.showOverlay = true;
            if ($rootScope.checkSession()) {
                init();
            }
        });
    });