var CameraService = angular.module('ManagedAccountService', [])

    .service('ManagedAccount', [
        '$window',
        '$state',
        '$http',
        '$rootScope',
        '$q',
        function ($window, $state, $http, $rootScope, $q) {
            return {
                getCustomerManagedAccount: function () {
                    var req = {
                        method: 'GET',
                        url: $rootScope.stowSecureURL + '/owner/account/managed/' + $rootScope.user.id,
                        headers: {
                            'Authorization': 'jwt ' + $rootScope.user.token
                        }
                    };

                    return $http(req);
                },
                updateCustomerManagedAccount: function (customerId) {
                    var req = {
                        method: 'PUT',
                        url: $rootScope.stowSecureURL + '/owner/account/managed/' + $rootScope.user.id,
                        headers: {
                            'Authorization': 'jwt ' + $rootScope.user.token
                        },
                        data: {stripeId: customerId}
                    };

                    return $http(req);
                },
                createManagedAccount: function (owner) {
                    var req = {
                        method: 'POST',
                        url: $rootScope.stowSecureURL + '/owner/account/managed',
                        headers: {
                            'Authorization': 'jwt ' + $rootScope.user.token
                        },
                        data: owner
                    };
                    console.log(req);
                    return $http(req);
                }

            }
        }]);

