angular.module('stow.controllers')
    .controller('ReactivateCtrl', function ($rootScope, $scope, $state, Account) {

        if (typeof analytics !== "undefined") {
            analytics.trackView("Reactivate Account");
            analytics.trackEvent("View State", "View Entered");
        }

        $scope.reactivate = function () {
            $scope.showOverlay = true;
            Account.reactivateAccount().then(function () {
                $rootScope.user.account.status.active = true;
                $rootScope.showMessage("Account Reactivated", "valid");
                analytics.trackEvent("Reactivate Account", "Success");
                if ($rootScope.user.isOwner) {
                    $state.go('app.manage');
                } else if (!$rootScope.user.isOwner) {
                    $state.go('app.browse');
                }
            }, function (error) {
                console.log(error);
                $rootScope.showMessage(error.message, "invalid");
            }).finally(function () {
                $scope.showOverlay = false;
            });
        };

        $scope.$on("$ionicView.beforeEnter", function () {
            $rootScope.checkSession();
        });
    });