var AddressService = angular.module('AddressService', [])
    .factory('Address', function ($http, $q) {
        var addressObjects = [],
            addressList = [];

        return {
            createAddressList: function (val) {
                addressObjects = addressList = [];
                return $http.get('https://maps.googleapis.com/maps/api/geocode/json', {
                    params: {
                        address: val,
                        components: "country:US",
                        sensor: false
                    }
                }).then(function (response) {
                    return response.data.results.map(function (item) {
                        addressObjects.push(item);
                        return item.formatted_address;
                    });
                });
            },

            selectAddress: function (fullAddress) {
                var deferred = $q.defer();
                angular.forEach(addressObjects, function (value) {
                    if (value.formatted_address === fullAddress) {
                        deferred.resolve(value);
                    }
                });
                return deferred.promise;
            },

            addressValid: function (address) {
                if (address.buildingNum && address.street && address.state && address.city && address.zip) {
                    return true;
                } else {
                    return false;
                }
            },

            getBlankAddress: function () {
                return {
                    buildingNum: '',
                    apartmentNum: '',
                    street: '',
                    city: '',
                    state: '',
                    country: '',
                    zip: ''
                };
            }
        }
    });