// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js

// This function
function handleOpenURL(url) {
    window.localStorage.setItem("external_url", url);
}

angular.module('stow', ['ionic', 'stow.controllers', 'ui.bootstrap', 'ui.mask', 'input-ssn', 'ngCordova', 'credit-cards', 'ngStorage','AccountService', 'AuthenticateService', 'RoleService', 'BankAccountService', 'CameraService', 'CreditCardService', 'DebitCardService', 'EmailService', 'LocationService', 'ManagedAccountService', 'MessagesService', 'PictureService', 'RentalService', 'ReservationService', 'AddressService'])

    .run(
    ['$state', '$window', '$ionicPlatform',
        function ($state, $window, $ionicPlatform) {
            $ionicPlatform.ready(function () {
                if (navigator.splashscreen) {
                    setTimeout(function(){
                        navigator.splashscreen.hide();
                    }, 200)
                }
                if (window.cordova && window.cordova.plugins.Keyboard) {
                    cordova.plugins.Keyboard.hideKeyboardAccessoryBar(false);
                    cordova.plugins.Keyboard.disableScroll(true);
                }
                if (window.StatusBar) {
                    StatusBar.hide();
                    ionic.Platform.fullScreen();
                }
                // Start Google Analytics
                if (typeof analytics !== "undefined") {
                    //PRODUCTION TRACKING ID
                    analytics.startTrackerWithId("UA-80492404-1");

                    //DEVELOPMENT TRACKING ID
                    // analytics.startTrackerWithId("UA-78366585-1");
                }
                // Check for external link to redirect
                if(window.localStorage.getItem("external_url")) {
                    routeExternalUrl();
                }
            });
            document.addEventListener("resume", onResume, false);
            function onResume () {
                routeExternalUrl();
            }
            function routeExternalUrl() {
                // Parse url and route accordingly with the correct params
                console.log(window.localStorage.getItem("external_url"));
                window.localStorage.removeItem("external_url");
            }
        }])

    .config(function ($stateProvider, $urlRouterProvider, $ionicConfigProvider, $sceDelegateProvider, $cordovaInAppBrowserProvider) {
        $stateProvider

            .state('app', {
                url: '/app',
                abstract: true,
                templateUrl: 'partials/menu.html',
                controller: 'AppCtrl'
            })

            .state('app.about', {
                cache: false,
                url: '/about',
                views: {
                    'menuContent': {
                        templateUrl: 'partials/about/about.html',
                        controller: 'AboutCtrl'
                    }
                }
            })

            .state('app.account', {
                cache: false,
                url: '/account',
                params: {
                    goBack: false
                },
                views: {
                    'menuContent': {
                        templateUrl: 'partials/account/account.html',
                        controller: 'AccountCtrl'
                    }
                }
            })

            .state('app.become-owner', {
                cache: false,
                url: '/become-owner',
                views: {
                    'menuContent': {
                        templateUrl: 'partials/become_owner.html',
                        controller: 'ChooseExperienceCtrl'
                    }
                }
            })

            .state('app.bank-account', {
                cache: false,
                url: '/bank-account/{tryingToList, fName, lName}',
                views: {
                    'menuContent': {
                        templateUrl: 'partials/account/bank_account/bank_account.html',
                        controller: 'BankAccountCtrl'
                    }
                }
            })

            .state('app.browse', {
                cache: true,
                url: '/browse',
                views: {
                    'menuContent': {
                        templateUrl: 'partials/browse.html',
                        controller: 'BrowseSpacesCtrl'
                    }
                }
            })

            .state('app.cancel-reservation', {
                cache: false,
                url: '/cancel-reservation',
                params: {
                    title: '',
                    reservationId: '',
                    username: ''
                },
                views: {
                    'menuContent': {
                        templateUrl: 'partials/reservations/cancel_reservation.html',
                        controller: 'CancelReservationCtrl'
                    }
                }
            })

            .state('app.choose-experience', {
                cache: false,
                url: '/choose-experience',
                views: {
                    'menuContent': {
                        templateUrl: 'partials/login/choose_experience.html',
                        controller: 'ChooseExperienceCtrl'
                    }
                }
            })

            .state('app.complete-profile', {
                cache: true,
                url: '/complete-profile',
                views: {
                    'menuContent': {
                        templateUrl: 'partials/account/complete_profile.html',
                        controller: 'CompleteProfileCtrl'
                    }
                }
            })

            .state('app.compose', {
                cache: false,
                url: '/compose',
                params: {
                    rentalId: '',
                    userId: '',
                    msg: {
                        sub: '',
                        body: ''
                    }
                },
                views: {
                    'menuContent': {
                        templateUrl: 'partials/messages/compose.html',
                        controller: 'ComposeCtrl'
                    }
                }
            })

            .state('app.credit-card', {
                cache: false,
                url: '/credit-card',
                views: {
                    'menuContent': {
                        templateUrl: 'partials/account/credit_card/credit_card.html',
                        controller: 'CreditCardCtrl'
                    }
                }
            })

            .state('app.credit-card-edit', {
                cache: false,
                url: '/credit-card-edit',
                params: {
                    goBack: false
                },
                views: {
                    'menuContent': {
                        templateUrl: 'partials/account/credit_card/credit_card_edit.html',
                        controller: 'EditCreditCardCtrl'
                    }
                }
            })

            .state('app.debit-card', {
                cache: false,
                url: '/debit-card',
                views: {
                    'menuContent': {
                        templateUrl: 'partials/account/debit_card/debit_card.html',
                        controller: 'DebitCardCtrl'
                    }
                }
            })

            .state('app.debit-card-edit', {
                cache: false,
                url: '/debit-card-edit',
                params: {
                    owner: ''
                },
                views: {
                    'menuContent': {
                        templateUrl: 'partials/account/debit_card/debit_card_edit.html',
                        controller: 'EditDebitCardCtrl'
                    }
                }
            })

            .state('app.edit-rental', {
                cache: false,
                url: '/edit-rental',
                params: {
                    rentalId: ""
                },
                views: {
                    'menuContent': {
                        templateUrl: 'partials/rentals/edit_rental.html',
                        controller: 'EditRentalCtrl'
                    }
                }
            })

            .state('app.faq', {
                cache: false,
                url: '/faq',
                params: {
                    view: ''
                },
                views: {
                    'menuContent': {
                        templateUrl: 'partials/about/faq.html',
                        controller: 'FAQCtrl'
                    }
                }
            })

            .state('app.legal', {
                cache: false,
                url: '/legal',
                params: {
                    view: ''
                },
                views: {
                    'menuContent': {
                        templateUrl: 'partials/about/legal.html',
                        controller: 'LegalCtrl'
                    }
                }
            })

            .state('app.list', {
                cache: false,
                url: '/list',
                views: {
                    'menuContent': {
                        templateUrl: 'partials/rentals/list_rental.html',
                        controller: 'ListRentalCtrl'
                    }
                }
            })

            .state('app.login', {
                cache: false,
                url: '/login',
                views: {
                    'menuContent': {
                        templateUrl: 'partials/login/login.html',
                        controller: 'LoginCtrl'
                    }
                }
            })

            .state('app.manage', {
                cache: false,
                url: '/manage-rental',
                views: {
                    'menuContent': {
                        templateUrl: 'partials/rentals/manage_rentals.html',
                        controller: 'ManageRentalsCtrl'
                    }
                }
            })

            .state('app.message-stow', {
                cache: true,
                url: '/message-stow',
                params: {
                    title: ""
                },
                views: {
                    'menuContent': {
                        templateUrl: 'partials/messages/message_stow.html',
                        controller: 'MessageStowCtrl'
                    }
                }
            })

            .state('app.messages', {
                cache: true,
                url: '/messages',
                views: {
                    'menuContent': {
                        templateUrl: 'partials/messages/messages.html',
                        controller: 'MessagesCtrl'
                    }
                }
            })

            .state('app.my-reservations', {
                cache: true,
                url: '/my-reservations',
                views: {
                    'menuContent': {
                        templateUrl: 'partials/reservations/my_reservations.html',
                        controller: 'MyReservationsCtrl'
                    }
                }
            })

            .state('app.owner-reservation', {
                cache: false,
                url: '/owner-reservation',
                params: {
                    "reservationId": ""
                },
                views: {
                    'menuContent': {
                        templateUrl: 'partials/reservations/owner_reservation.html',
                        controller: 'OwnerReservationCtrl'
                    }
                }
            })

            .state('app.reactivate', {
                cache: true,
                url: '/reactivate',
                views: {
                    'menuContent': {
                        templateUrl: 'partials/account/reactivate.html',
                        controller: 'ReactivateCtrl'
                    }
                }
            })

            .state('app.renter-reservation', {
                cache: false,
                url: '/renter-reservation',
                params: {
                    "reservationId": ""
                },
                views: {
                    'menuContent': {
                        templateUrl: 'partials/reservations/renter_reservation.html',
                        controller: 'RenterReservationCtrl'
                    }
                }
            })

            .state('app.request', {
                cache: false,
                url: '/request',
                params: {
                    "rental": {}
                },
                views: {
                    'menuContent': {
                        templateUrl: 'partials/reservations/request.html',
                        controller: 'RequestCtrl'
                    }
                }
            })

            .state('app.terms', {
                cache: false,
                url: '/terms',
                views: {
                    'menuContent': {
                        templateUrl: 'partials/about/terms.html'
                    }
                }
            })

            .state('app.view-message', {
                cache: false,
                url: '/view-message',
                params: {
                    messageId: "",
                    mailbox: ""
                },
                views: {
                    'menuContent': {
                        templateUrl: 'partials/messages/view_message.html',
                        controller: 'ViewMessageCtrl'
                    }
                }
            })

            .state('app.view-rental', {
                cache: false,
                url: '/view-rental/',
                params: {
                    rentalId: ""
                },
                views: {
                    'menuContent': {
                        templateUrl: 'partials/rentals/view_rental.html',
                        controller: 'ViewRentalCtrl'
                    }
                }
            });

        $sceDelegateProvider.resourceUrlWhitelist([
            // Allow same origin resource loads.
            'self',
            // Allow loading from our assets domain.
            'https://juststowit.com/resources/partials/legal/privacy.html',
            'https://juststowit.com/resources/partials/legal/terms.html',
            'https://juststowit.com/resources/partials/faq/owner.html',
            'https://juststowit.com/resources/partials/faq/renter.html'
        ]);
        $urlRouterProvider.otherwise('/app/browse');
        $ionicConfigProvider.views.swipeBackEnabled(false);
        $ionicConfigProvider.views.maxCache(2);
        $ionicConfigProvider.form.toggle('large');
        $ionicConfigProvider.navBar.alignTitle('center');

    }).directive('validEmail', function (emailRegex) {
        return {
            require: 'ngModel',
            link: function ($scope, $element, $attrs, ngModel) {
                ngModel.$validators.validEmail = function (val) {
                    if (!val) {
                        return true;
                    }
                    return emailRegex.test(val);
                };
            }
        };
    }).value('emailRegex', /^(?:[\w\!\#\$\%\&\'\*\+\-\/\=\?\^\`\{\|\}\~]+\.)*[\w\!\#\$\%\&\'\*\+\-\/\=\?\^\`\{\|\}\~]+@(?:(?:(?:[a-zA-Z0-9](?:[a-zA-Z0-9\-](?!\.)){0,61}[a-zA-Z0-9]?\.)+[a-zA-Z0-9](?:[a-zA-Z0-9\-](?!$)){0,61}[a-zA-Z0-9]?)|(?:\[(?:(?:[01]?\d{1,2}|2[0-4]\d|25[0-5])\.){3}(?:[01]?\d{1,2}|2[0-4]\d|25[0-5])\]))$/);