var CameraService = angular.module('LocationService', [])

    .service('Location', [
        '$http',
        '$q',
        '$cordovaGeolocation',
        function ($http, $q, $cordovaGeolocation) {
            return {
                getLocation: function () {
                    var deferred = $q.defer();
                    var posOptions = {timeout: 6000, enableHighAccuracy: true};
                    $cordovaGeolocation
                        .getCurrentPosition(posOptions)
                        .then(function (position) {
                            console.log("got location");
                            var pos = {
                                'lat': position.coords.latitude,
                                'long': position.coords.longitude
                            };
                            deferred.resolve(pos);
                        }, function (error) {
                            deferred.reject(error);
                        });
                    return deferred.promise;
                },

                getCurrentAddress: function (position) {
                    var deferred = $q.defer();
                    $http.get('http://maps.googleapis.com/maps/api/geocode/json', {
                        params: {
                            latlng: position.lat + "," + position.long
                        }
                    }).then(function (response) {
                        console.log(response);
                        if (response.data.status === "ZERO_RESULTS") {
                            deferred.reject("No address found");
                        } else {
                            deferred.resolve(response.data.results[0]);
                        }
                    });
                    return deferred.promise;
                }
            }
        }]);

