angular.module('stow.controllers')
    .controller('ComposeCtrl', function ($rootScope, $scope, $state, $stateParams, $timeout, $ionicHistory, Messages) {

        if (typeof analytics !== "undefined") {
            analytics.trackView("Compose Message");
        }

        $scope.showOverlay = $scope.loading = true;
        $scope.newMessage = {
            "to": {
                "id": $stateParams.userId
            },
            "rentalId": $stateParams.rentalId,
            "msg": $stateParams.msg
        };

        $scope.sendMessage = function () {
            $scope.showOverlay = true;
            Messages.sendMessage($scope.newMessage).then(function (result) {
                analytics.trackEvent("Send Message", "Success");
                $rootScope.showMessage("Message Sent", "valid");
                $ionicHistory.goBack();
                $scope.showOverlay = false;
            }, function (error) {
                console.log(error);
                $rootScope.showMessage(error.message, "invalid");
                $scope.showOverlay = false;
            });
        };

        $scope.$on("$stateChangeSuccess", function () {
            $timeout(function () {
                if ($scope.newMessage.msg.body) {
                    if ($scope.newMessage.msg.sub.indexOf("Re:") === -1) {
                        $scope.newMessage.msg.sub = "Re: " + $scope.newMessage.msg.sub;
                        // Truncate the subject because it was making the form field invalid
                        if($scope.newMessage.msg.sub.length > 40) {
                            $scope.newMessage.msg.sub = $scope.newMessage.msg.sub.substring(0, 39);
                        }
                    }
                    $scope.newMessage.msg.body = '\n------------------------------\n' + $scope.newMessage.msg.body;
                }
                $scope.showOverlay = $scope.loading = false;
            }, 300);
        });

        $scope.$on('$ionicView.beforeEnter', function () {
            $rootScope.checkSession();
        });
    });