angular.module('stow.controllers')
    .controller('MessageStowCtrl', function ($rootScope, $scope, $state, $stateParams, $ionicSlideBoxDelegate, $ionicHistory, Account, Email) {

        if (typeof analytics !== "undefined") {
            analytics.trackView("Message Stow");
        }

        $scope.showOverlay = true;
        $ionicSlideBoxDelegate.enableSlide(false);
        $scope.slide = 0;

        $scope.init = function () {
            $scope.title = $stateParams.title;
            $scope.msg = {message: "", subject: $scope.title};

            if($rootScope.user.id){
                Account.getUserData().then(function (result) {
                    $scope.msg.name = result.fn + " " + result.ln;
                    $scope.msg.email = result.un;

                }, function (error) {
                    $rootScope.showMessage(error.message, "invalid");
                }).finally(function(){
                    $scope.changeSlide($scope.slide);
                });
            }else {
                $scope.msg.name = "Browsing User";
                $scope.msg.email = "Unknown";
                $scope.changeSlide($scope.slide);
            }
        };

        // Change the slide within the ion-slide-box
        $scope.changeSlide = function (slideNumber) {
            $scope.showOverlay = true;
            if (slideNumber === 0) {
                $scope.title = $stateParams.title;
            } else if (slideNumber === 1) {
                $scope.title = "Success";
            }
            $scope.slide = slideNumber;
            $ionicSlideBoxDelegate.slide(slideNumber);
            $ionicSlideBoxDelegate.update();
            $scope.showOverlay = false;
        };

        $scope.send = function () {
            $scope.showOverlay = true;
            Email.sendStowEmail($scope.msg).then(function (result) {
                analytics.trackEvent("Send Message", "Success");
                $scope.changeSlide(1);
            }, function (error) {
                $rootScope.showMessage(error.message, "invalid");
            }).finally(function () {
                $scope.showOverlay = false;
            });
        };
    });