angular.module('stow.controllers')

    .controller('CancelReservationCtrl', function ($rootScope, $scope, $state, $stateParams, Reservation) {

        if(typeof analytics !== "undefined"){
            analytics.trackView("Cancel/Decline Reservation");
        }

        $scope.title = $stateParams.title;
        $scope.username = $stateParams.username;
        $scope.rejectionReason = "";

        if($scope.title === "Cancel Reservation"){
            $scope.buttonText = "Cancel Reservation";
        }else {
            $scope.buttonText = "Decline Reservation";
        }

        $scope.submit = function () {
            $scope.showOverlay = true;
            var message = '',
                status = '';
            if ($scope.title === "Cancel Reservation") {
                message = "Reservation Canceled";
                status = "canceled";
            } else {
                message = "Request Declined";
                status = "declined";
            }
            Reservation.updateReservation($stateParams.reservationId, status, $scope.rejectionReason, $scope.userComment)
                .then(function (result) {
                    if(status === 'declined'){
                        $rootScope.user.reservations.pending--;
                        analytics.trackEvent("Update Reservation", "Declined");
                    }else {
                        analytics.trackEvent("Update Reservation", "Canceled");
                    }
                    $state.go("app.my-reservations");
                    $rootScope.showMessage(message, "valid");
                }, function (error) {
                    analytics.trackException("Failed to update reservation", false);
                    console.log(error);
                    $rootScope.showMessage(error.message, "invalid");
                }).finally(function () {
                    $scope.showOverlay = false;
                });
        };

        $scope.$on("$ionicView.beforeEnter", function () {
            $rootScope.checkSession();
        });
    });